#include <stdio.h>

// To compile:

// OS X GLUT: 
//   g++ -o big big.cxx -framework OpenGL -framework GLUT

// FreeGLUT (on OS X, with Macport's FreeGLUT): 
//   g++ -o big big.cxx -framework OpenGL -I/opt/local/include -L/opt/local/lib -lglut

// FLTK
//   g++ -o big big.cxx `fltk-config --cxxflags --ldflags --use-gl`

#include <GLUT/glut.h>		// GLUT and FreeGLUT version
// #include <FL/glut.H>		// FLTK version

// Empty callback functions for testing.
void displayFunc()
{
}

void reshapeFunc(int w, int h)
{
}

void keyboardFunc(unsigned char key, int x, int y)
{
}

void mouseFunc(int b, int state, int x, int y)
{
}

void motionFunc(int x, int y)
{
}

void passiveMotionFunc(int x, int y)
{
}

void entryFunc(int s)
{
}

void visibilityFunc(int s)
{
}

void idleFunc()
{
}

void timerFunc(int value)
{
}

void menuStateFunc(int state)
{
}

void menuStatusFunc(int status, int x, int y)
{
}

void specialFunc(int key, int x, int y)
{
}

void overlayDisplayFunc()
{
}

int main(int argc, char *argv)
{
    glutInit(&argc, &argv);

    // Create 2 windows.
    int win1 = glutCreateWindow("Window 1");
    int win2 = glutCreateWindow("Window 2");

    // Destroy the current window.
    int current = glutGetWindow();
    printf("%d is current\n", current);
    glutDestroyWindow(current);

    // Ask GLUT to redisplay things.
    glutPostRedisplay();

    // Find out which window is current.
    current = glutGetWindow();
    printf("%d is current\n", current);

    // Set window title
    glutSetWindowTitle("Non-existent");

    // Set icon title
    glutSetIconTitle("Non-existent");

    // Position window
    glutPositionWindow(10, 20);

    // Reshape window
    glutReshapeWindow(100, 200);

    // Pop window
    glutPopWindow();

    // Iconify window
    glutIconifyWindow();

    // Show window
    glutShowWindow();

    // Hide window
    glutHideWindow();

    // Go to full screen mode
    glutFullScreen();

    // Set the cursor
    glutSetCursor(GLUT_CURSOR_INFO);

    // Establish an overlay
    glutEstablishOverlay();

    // Remove overlay
    glutRemoveOverlay();

    // Choose a layer
    glutUseLayer(GLUT_NORMAL);
    glutUseLayer(GLUT_OVERLAY);

    // Post display on a layer
    glutPostOverlayRedisplay();

    // Show overlay
    glutShowOverlay();

    // Hide overlay
    glutHideOverlay();

    // Attach a menu
    glutAttachMenu(0);

    // Detach a menu
    glutDetachMenu(0);

    // Specify callbacks
    glutDisplayFunc(displayFunc);
    glutReshapeFunc(reshapeFunc);
    glutKeyboardFunc(keyboardFunc);
    glutMouseFunc(mouseFunc);
    glutMotionFunc(motionFunc);
    glutPassiveMotionFunc(passiveMotionFunc);
    glutEntryFunc(entryFunc);
    glutVisibilityFunc(visibilityFunc);
    glutIdleFunc(idleFunc);
    glutTimerFunc(1000, timerFunc, 42);
    glutMenuStateFunc(menuStateFunc);
    glutMenuStatusFunc(menuStatusFunc);
    glutSpecialFunc(specialFunc);
    glutOverlayDisplayFunc(overlayDisplayFunc);

    // Swap buffers
    glutSwapBuffers();

    // GLUT gets
    printf("GLUT_WINDOW_X = %d\n", glutGet(GLUT_WINDOW_X));
    printf("GLUT_WINDOW_Y = %d\n", glutGet(GLUT_WINDOW_Y));
    printf("GLUT_WINDOW_WIDTH = %d\n", glutGet(GLUT_WINDOW_WIDTH));
    printf("GLUT_WINDOW_HEIGHT = %d\n", glutGet(GLUT_WINDOW_HEIGHT));
    printf("GLUT_WINDOW_PARENT = %d\n", glutGet(GLUT_WINDOW_PARENT));

    // GLUT layer gets
    printf("GLUT_OVERLAY_POSSIBLE = %d\n", glutGet(GLUT_OVERLAY_POSSIBLE));
    printf("GLUT_NORMAL_DAMAGED = %d\n", glutGet(GLUT_NORMAL_DAMAGED));

    return 0;
}
